diff --git a/src/http/ngx_http_core_module.c b/src/http/ngx_http_core_module.c
index 73d7af9..d4d3e66 100644
--- a/src/http/ngx_http_core_module.c
+++ b/src/http/ngx_http_core_module.c
@@ -838,6 +838,14 @@ ngx_http_core_find_config_phase(ngx_http_request_t *r,
 
     clcf = ngx_http_get_module_loc_conf(r, ngx_http_core_module);
 
+    if (!clcf->regex_locations) {
+        r->uri_remainder.len = r->uri.len - clcf->name.len;
+        r->uri_remainder.data = r->uri.data + clcf->name.len;
+    } else {
+        r->uri_remainder.len = 0;
+        r->uri_remainder.data = NULL;
+    }
+
     if (!r->internal && clcf->internal) {
         ngx_http_finalize_request(r, NGX_HTTP_NOT_FOUND);
         return NGX_OK;
@@ -2096,6 +2104,7 @@ ngx_http_subrequest(ngx_http_request_t *r,
     ngx_http_clear_content_length(sr);
     ngx_http_clear_accept_ranges(sr);
     ngx_http_clear_last_modified(sr);
+    ngx_http_clear_etag(sr);
 
     sr->request_body = r->request_body;
 
diff --git a/src/http/ngx_http_core_module.h b/src/http/ngx_http_core_module.h
index 2c4e45a..e524d41 100644
--- a/src/http/ngx_http_core_module.h
+++ b/src/http/ngx_http_core_module.h
@@ -495,5 +495,15 @@ extern ngx_str_t  ngx_http_core_get_method;
         r->headers_out.last_modified = NULL;                                  \
     }
 
+#define ngx_http_clear_etag(r)                                                \
+                                                                              \
+    r->headers_out.etag_size = -1;                                            \
+    r->headers_out.etag_time = -1;                                            \
+    r->headers_out.etag_uniq = (ngx_file_uniq_t) -1;                          \
+    if (r->headers_out.etag) {                                                \
+        r->headers_out.etag->hash = 0;                                        \
+        r->headers_out.etag = NULL;                                           \
+    }
+
 
 #endif /* _NGX_HTTP_CORE_H_INCLUDED_ */
diff --git a/src/http/ngx_http_header_filter_module.c b/src/http/ngx_http_header_filter_module.c
index 332fceb..8136ca6 100644
--- a/src/http/ngx_http_header_filter_module.c
+++ b/src/http/ngx_http_header_filter_module.c
@@ -197,6 +197,20 @@ ngx_http_header_filter(ngx_http_request_t *r)
         }
     }
 
+    if (r->headers_out.etag_size != -1 ||
+	r->headers_out.etag_time != -1 ||
+	r->headers_out.etag_uniq != (ngx_file_uniq_t) -1) {
+        if (r->headers_out.status != NGX_HTTP_OK
+            && r->headers_out.status != NGX_HTTP_PARTIAL_CONTENT
+            && r->headers_out.status != NGX_HTTP_NOT_MODIFIED)
+        {
+            r->headers_out.etag_size = -1;
+            r->headers_out.etag_time = -1;
+            r->headers_out.etag_uniq = (ngx_file_uniq_t) -1;
+            r->headers_out.etag = NULL;
+	}
+    }
+
     len = sizeof("HTTP/1.x ") - 1 + sizeof(CRLF) - 1
           /* the end of the header */
           + sizeof(CRLF) - 1;
@@ -227,6 +241,10 @@ ngx_http_header_filter(ngx_http_request_t *r)
                 r->headers_out.last_modified = NULL;
                 r->headers_out.content_length = NULL;
                 r->headers_out.content_length_n = -1;
+                r->headers_out.etag_size = 1;
+                r->headers_out.etag_time = 1;
+                r->headers_out.etag_uniq = 1;
+                r->headers_out.etag = NULL;
             }
 
             status -= NGX_HTTP_OK;
@@ -275,6 +293,11 @@ ngx_http_header_filter(ngx_http_request_t *r)
         }
     }
 
+    if (r->keepalive && r->headers_out.content_length_n == -1) {
+        r->headers_out.content_length = NULL;
+        r->headers_out.content_length_n = 0;
+    }
+
     clcf = ngx_http_get_module_loc_conf(r, ngx_http_core_module);
 
     if (r->headers_out.server == NULL) {
@@ -309,6 +332,15 @@ ngx_http_header_filter(ngx_http_request_t *r)
         len += sizeof("Last-Modified: Mon, 28 Sep 1970 06:00:00 GMT" CRLF) - 1;
     }
 
+    if (r->headers_out.etag == NULL
+        && r->headers_out.etag_size != -1
+        && r->headers_out.etag_time != -1
+        && r->headers_out.etag_uniq != (ngx_file_uniq_t) -1)
+    {
+        len += sizeof("ETag: ") - 1 + NGX_OFF_T_LEN + sizeof("_") - 1
+               + NGX_TIME_T_LEN + sizeof("_") - 1 + NGX_INT_T_LEN + sizeof(CRLF) - 1;
+    }
+
     if (r->headers_out.location
         && r->headers_out.location->value.len
         && r->headers_out.location->value.data[0] == '/')
@@ -503,6 +535,17 @@ ngx_http_header_filter(ngx_http_request_t *r)
         *b->last++ = CR; *b->last++ = LF;
     }
 
+    if (r->headers_out.etag == NULL
+        && r->headers_out.etag_size != -1
+        && r->headers_out.etag_time != -1
+        && r->headers_out.etag_uniq != (ngx_file_uniq_t) -1)
+    {
+        b->last = ngx_sprintf(b->last, "ETag: %XO-%XM-%Xd" CRLF,
+                              r->headers_out.etag_size,
+                              r->headers_out.etag_time,
+                              r->headers_out.etag_uniq);
+    }
+
     if (host.data) {
 
         p = b->last + sizeof("Location: ") - 1;
diff --git a/src/http/ngx_http_request.c b/src/http/ngx_http_request.c
index 32f120c..3abb61a 100644
--- a/src/http/ngx_http_request.c
+++ b/src/http/ngx_http_request.c
@@ -84,6 +84,10 @@ ngx_http_header_t  ngx_http_headers_in[] = {
                  offsetof(ngx_http_headers_in_t, if_modified_since),
                  ngx_http_process_unique_header_line },
 
+    { ngx_string("If-Match"),
+                 offsetof(ngx_http_headers_in_t, if_match),
+                 ngx_http_process_unique_header_line },
+
     { ngx_string("User-Agent"), offsetof(ngx_http_headers_in_t, user_agent),
                  ngx_http_process_user_agent },
 
@@ -245,8 +249,12 @@ ngx_http_init_request(ngx_event_t *rev)
     struct sockaddr_in6        *sin6;
     ngx_http_in6_addr_t        *addr6;
 #endif
-
 #if (NGX_STAT_STUB)
+    ngx_int_t        ct;
+    ngx_atomic_int_t ls;
+    ngx_atomic_int_t sr;
+    ngx_atomic_int_t rl;
+
     ngx_atomic_fetch_add(ngx_stat_reading, -1);
 #endif
 
@@ -483,6 +491,9 @@ ngx_http_init_request(ngx_event_t *rev)
     r->headers_in.keep_alive_n = -1;
     r->headers_out.content_length_n = -1;
     r->headers_out.last_modified_time = -1;
+    r->headers_out.etag_size = -1;
+    r->headers_out.etag_time = -1;
+    r->headers_out.etag_uniq = (ngx_file_uniq_t) -1;
 
     r->uri_changes = NGX_HTTP_MAX_URI_CHANGES + 1;
     r->subrequests = NGX_HTTP_MAX_SUBREQUESTS + 1;
@@ -498,6 +509,26 @@ ngx_http_init_request(ngx_event_t *rev)
     ngx_atomic_fetch_add(ngx_stat_reading, 1);
     r->stat_reading = 1;
     ngx_atomic_fetch_add(ngx_stat_requests, 1);
+
+    ct = ngx_time();
+    ls = *ngx_stat_requests_last_seconds;
+
+    if (ct > ls &&
+	(ngx_accept_mutex_ptr == NULL ||
+	 (ngx_accept_mutex_ptr && ngx_atomic_cmp_set(ngx_accept_mutex_ptr, 0, ngx_pid)))) {
+
+      sr = *ngx_stat_requests;
+      rl = *ngx_stat_requests_last;
+      
+      ngx_log_error(NGX_LOG_INFO, c->log, 0, "ct:%d ls:%d sr:%d rl:%d", ct, ls, sr, rl);
+      *ngx_stat_requests_per_seconds = (sr - rl) / (ct - ls);
+      *ngx_stat_requests_last = sr;
+      *ngx_stat_requests_last_seconds = ct;
+
+      if (ngx_accept_mutex_ptr) {
+	ngx_atomic_cmp_set(ngx_accept_mutex_ptr, ngx_pid, 0);
+      }
+    }
 #endif
 
     rev->handler(rev);
diff --git a/src/http/ngx_http_request.h b/src/http/ngx_http_request.h
index 4fef7c3..8b31367 100644
--- a/src/http/ngx_http_request.h
+++ b/src/http/ngx_http_request.h
@@ -164,6 +164,7 @@ typedef struct {
     ngx_table_elt_t                  *host;
     ngx_table_elt_t                  *connection;
     ngx_table_elt_t                  *if_modified_since;
+    ngx_table_elt_t                  *if_match;
     ngx_table_elt_t                  *user_agent;
     ngx_table_elt_t                  *referer;
     ngx_table_elt_t                  *content_length;
@@ -255,6 +256,10 @@ typedef struct {
     off_t                             content_length_n;
     time_t                            date_time;
     time_t                            last_modified_time;
+
+    off_t                             etag_size;
+    time_t                            etag_time;
+    ngx_file_uniq_t                   etag_uniq;
 } ngx_http_headers_out_t;
 
 
@@ -373,6 +378,7 @@ struct ngx_http_request_s {
 
     ngx_str_t                         request_line;
     ngx_str_t                         uri;
+    ngx_str_t                         uri_remainder;
     ngx_str_t                         args;
     ngx_str_t                         exten;
     ngx_str_t                         unparsed_uri;
@@ -462,6 +468,7 @@ struct ngx_http_request_s {
      * we use the single bits in the request structure
      */
     unsigned                          limit_zone_set:1;
+    unsigned                          limit_var_set:1;
     unsigned                          limit_req_set:1;
 
 #if 0
diff --git a/src/http/ngx_http_special_response.c b/src/http/ngx_http_special_response.c
index 9765430..e340692 100644
--- a/src/http/ngx_http_special_response.c
+++ b/src/http/ngx_http_special_response.c
@@ -627,6 +627,7 @@ ngx_http_send_special_response(ngx_http_request_t *r,
 
     ngx_http_clear_accept_ranges(r);
     ngx_http_clear_last_modified(r);
+    ngx_http_clear_etag(r);
 
     rc = ngx_http_send_header(r);
 
@@ -725,6 +726,7 @@ ngx_http_send_refresh(ngx_http_request_t *r)
 
     ngx_http_clear_accept_ranges(r);
     ngx_http_clear_last_modified(r);
+    ngx_http_clear_etag(r);
 
     rc = ngx_http_send_header(r);
 
diff --git a/src/http/ngx_http_upstream.c b/src/http/ngx_http_upstream.c
index 0a6fddb..34a81a5 100644
--- a/src/http/ngx_http_upstream.c
+++ b/src/http/ngx_http_upstream.c
@@ -9,6 +9,10 @@
 #include <ngx_http.h>
 
 
+typedef struct {
+    ngx_uint_t           count_limit;
+} ngx_http_upstream_local_conf_t;
+
 #if (NGX_HTTP_CACHE)
 static ngx_int_t ngx_http_upstream_cache(ngx_http_request_t *r,
     ngx_http_upstream_t *u);
@@ -124,6 +128,10 @@ static char *ngx_http_upstream_server(ngx_conf_t *cf, ngx_command_t *cmd,
 static void *ngx_http_upstream_create_main_conf(ngx_conf_t *cf);
 static char *ngx_http_upstream_init_main_conf(ngx_conf_t *cf, void *conf);
 
+static void *ngx_http_upstream_create_local_conf(ngx_conf_t *cf);
+static char *ngx_http_upstream_merge_local_conf(ngx_conf_t *cf,
+    void *parent, void *child);
+
 #if (NGX_HTTP_SSL)
 static void ngx_http_upstream_ssl_init_connection(ngx_http_request_t *,
     ngx_http_upstream_t *u, ngx_connection_t *c);
@@ -263,6 +271,14 @@ static ngx_command_t  ngx_http_upstream_commands[] = {
       0,
       NULL },
 
+    { ngx_string("upstream_count_limit"),
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_HTTP_LIF_CONF
+                        |NGX_CONF_FLAG,
+      ngx_conf_set_num_slot,
+      NGX_HTTP_LOC_CONF_OFFSET,
+      offsetof(ngx_http_upstream_local_conf_t, count_limit),
+      NULL },
+
       ngx_null_command
 };
 
@@ -277,8 +293,8 @@ static ngx_http_module_t  ngx_http_upstream_module_ctx = {
     NULL,                                  /* create server configuration */
     NULL,                                  /* merge server configuration */
 
-    NULL,                                  /* create location configuration */
-    NULL                                   /* merge location configuration */
+    ngx_http_upstream_create_local_conf,   /* create location configuration */
+    ngx_http_upstream_merge_local_conf     /* merge location configuration */
 };
 
 
@@ -341,6 +357,9 @@ ngx_http_upstream_init(ngx_http_request_t *r)
     ngx_http_core_loc_conf_t       *clcf;
     ngx_http_upstream_srv_conf_t   *uscf, **uscfp;
     ngx_http_upstream_main_conf_t  *umcf;
+    ngx_http_upstream_local_conf_t  *conf;
+
+    conf = ngx_http_get_module_loc_conf(r, ngx_http_upstream_module);
 
     c = r->connection;
 
@@ -360,6 +379,11 @@ ngx_http_upstream_init(ngx_http_request_t *r)
         r->write_event_handler = ngx_http_upstream_wr_check_broken_connection;
     }
 
+    if (conf->count_limit) {
+	u->count_limit = conf->count_limit;
+	u->count_limit_origin = conf->count_limit;
+    }
+
     if (ngx_event_flags & NGX_USE_CLEAR_EVENT) {
 
         if (!c->write->active) {
@@ -4236,3 +4260,31 @@ ngx_http_upstream_init_main_conf(ngx_conf_t *cf, void *conf)
 
     return NGX_CONF_OK;
 }
+
+
+static void *
+ngx_http_upstream_create_local_conf(ngx_conf_t *cf)
+{
+    ngx_http_upstream_local_conf_t  *conf;
+
+    conf = ngx_pcalloc(cf->pool, sizeof(ngx_http_upstream_local_conf_t));
+    if (conf == NULL) {
+        return NGX_CONF_ERROR;
+    }
+
+    conf->count_limit = NGX_CONF_UNSET_UINT;
+
+    return conf;
+}
+
+static char *
+ngx_http_upstream_merge_local_conf(ngx_conf_t *cf, void *parent, void *child)
+{
+    ngx_http_upstream_local_conf_t  *prev = parent;
+    ngx_http_upstream_local_conf_t  *conf = child;
+
+    ngx_conf_merge_uint_value(conf->count_limit,
+                              prev->count_limit, 0);
+
+    return NGX_CONF_OK;
+}
diff --git a/src/http/ngx_http_upstream.h b/src/http/ngx_http_upstream.h
index 95b396e..e3f9076 100644
--- a/src/http/ngx_http_upstream.h
+++ b/src/http/ngx_http_upstream.h
@@ -291,6 +291,9 @@ struct ngx_http_upstream_s {
 
     ngx_http_cleanup_pt             *cleanup;
 
+    ngx_flag_t                       count_limit;
+    ngx_uint_t                       count_limit_origin;
+
     unsigned                         store:1;
     unsigned                         cacheable:1;
     unsigned                         accel:1;
diff --git a/src/http/ngx_http_upstream_round_robin.c b/src/http/ngx_http_upstream_round_robin.c
index 52bd808..088d3f1 100644
--- a/src/http/ngx_http_upstream_round_robin.c
+++ b/src/http/ngx_http_upstream_round_robin.c
@@ -214,6 +214,8 @@ ngx_http_upstream_init_round_robin_peer(ngx_http_request_t *r,
         }
 
         r->upstream->peer.data = rrp;
+        rrp->u = r->upstream;
+        rrp->peers_is_backup = 0;
     }
 
     rrp->peers = us->peer.data;
@@ -267,6 +269,8 @@ ngx_http_upstream_create_round_robin_peer(ngx_http_request_t *r,
         }
 
         r->upstream->peer.data = rrp;
+	rrp->u = r->upstream;
+	rrp->peers_is_backup = 0;
     }
 
     peers = ngx_pcalloc(r->pool, sizeof(ngx_http_upstream_rr_peers_t)
@@ -371,6 +375,17 @@ ngx_http_upstream_get_round_robin_peer(ngx_peer_connection_t *pc, void *data)
 
     now = ngx_time();
 
+    if (!rrp->peers_is_backup &&
+	rrp->u->count_limit_origin &&
+	rrp->u->count_limit == 0) {
+	ngx_log_error(NGX_LOG_INFO, pc->log, 0,
+		      "http next upstream limited by upstream_count_limit %d ",
+		      rrp->u->count_limit_origin);
+	goto failed;
+    } else if (rrp->u->count_limit) {
+	rrp->u->count_limit--;
+    }
+
     /* ngx_lock_mutex(rrp->peers->mutex); */
 
     if (rrp->peers->last_cached) {
@@ -547,6 +562,8 @@ failed:
         rrp->peers = peers->next;
         pc->tries = rrp->peers->number;
 
+	rrp->peers_is_backup = 1;
+
         n = rrp->peers->number / (8 * sizeof(uintptr_t)) + 1;
         for (i = 0; i < n; i++) {
              rrp->tried[i] = 0;
diff --git a/src/http/ngx_http_upstream_round_robin.h b/src/http/ngx_http_upstream_round_robin.h
index 2213154..0546ef2 100644
--- a/src/http/ngx_http_upstream_round_robin.h
+++ b/src/http/ngx_http_upstream_round_robin.h
@@ -58,6 +58,8 @@ typedef struct {
     ngx_uint_t                      current;
     uintptr_t                      *tried;
     uintptr_t                       data;
+    ngx_http_upstream_t            *u;
+    ngx_uint_t                      peers_is_backup;
 } ngx_http_upstream_rr_peer_data_t;
 
 
diff --git a/src/http/ngx_http_variables.c b/src/http/ngx_http_variables.c
index 0c46c35..7d31d5b 100644
--- a/src/http/ngx_http_variables.c
+++ b/src/http/ngx_http_variables.c
@@ -7,6 +7,7 @@
 #include <ngx_config.h>
 #include <ngx_core.h>
 #include <ngx_http.h>
+#include <ngx_md5.h>
 #include <nginx.h>
 
 
@@ -27,6 +28,18 @@ static ngx_int_t ngx_http_variable_unknown_header_out(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data);
 static ngx_int_t ngx_http_variable_cookie(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data);
+#if (NGX_HTTP_SSI)
+static ngx_int_t ngx_http_variable_ssi(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data);
+#endif
+static ngx_int_t ngx_http_variable_urlencode(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data);
+static ngx_int_t ngx_http_variable_urldecode(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data);
+static ngx_int_t ngx_http_variable_crc32(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data);
+static ngx_int_t ngx_http_variable_md5(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data);
 static ngx_int_t ngx_http_variable_argument(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data);
 
@@ -73,6 +86,8 @@ static ngx_int_t ngx_http_variable_sent_location(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data);
 static ngx_int_t ngx_http_variable_sent_last_modified(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data);
+static ngx_int_t ngx_http_variable_sent_etag(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data);
 static ngx_int_t ngx_http_variable_sent_connection(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data);
 static ngx_int_t ngx_http_variable_sent_keep_alive(ngx_http_request_t *r,
@@ -86,6 +101,8 @@ static ngx_int_t ngx_http_variable_hostname(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data);
 static ngx_int_t ngx_http_variable_pid(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data);
+static ngx_int_t ngx_http_variable_timestamp(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data);
 
 /*
  * TODO:
@@ -158,6 +175,10 @@ static ngx_http_variable_t  ngx_http_core_variables[] = {
       offsetof(ngx_http_request_t, uri),
       NGX_HTTP_VAR_NOCACHEABLE, 0 },
 
+    { ngx_string("uri_remainder"), NULL, ngx_http_variable_request,
+      offsetof(ngx_http_request_t, uri_remainder),
+      NGX_HTTP_VAR_NOCACHEABLE, 0 },
+
     { ngx_string("document_uri"), NULL, ngx_http_variable_request,
       offsetof(ngx_http_request_t, uri),
       NGX_HTTP_VAR_NOCACHEABLE, 0 },
@@ -218,6 +239,9 @@ static ngx_http_variable_t  ngx_http_core_variables[] = {
     { ngx_string("sent_http_last_modified"), NULL,
       ngx_http_variable_sent_last_modified, 0, 0, 0 },
 
+    { ngx_string("sent_http_etag"), NULL,
+      ngx_http_variable_sent_etag, 0, 0, 0 },
+
     { ngx_string("sent_http_connection"), NULL,
       ngx_http_variable_sent_connection, 0, 0, 0 },
 
@@ -244,6 +268,9 @@ static ngx_http_variable_t  ngx_http_core_variables[] = {
     { ngx_string("pid"), NULL, ngx_http_variable_pid,
       0, 0, 0 },
 
+    { ngx_string("timestamp"), NULL, ngx_http_variable_timestamp,
+      0, 0, 0 },
+
     { ngx_null_string, NULL, NULL, 0, 0, 0 }
 };
 
@@ -505,6 +532,53 @@ ngx_http_get_variable(ngx_http_request_t *r, ngx_str_t *name, ngx_uint_t key,
         return NULL;
     }
 
+#if (NGX_HTTP_SSI)
+    if (ngx_strncmp(name->data, "ssi_", 4) == 0) {
+
+        if (ngx_http_variable_ssi(r, vv, (uintptr_t) name) == NGX_OK) {
+            return vv;
+        }
+
+        return NULL;
+    }
+#endif
+
+    if (ngx_strncmp(name->data, "urlencode_", 10) == 0) {
+
+        if (ngx_http_variable_urlencode(r, vv, (uintptr_t) name) == NGX_OK) {
+            return vv;
+        }
+
+        return NULL;
+    }
+
+    if (ngx_strncmp(name->data, "urldecode_", 10) == 0) {
+
+        if (ngx_http_variable_urldecode(r, vv, (uintptr_t) name) == NGX_OK) {
+            return vv;
+        }
+
+        return NULL;
+    }
+
+    if (ngx_strncmp(name->data, "crc32_", 6) == 0) {
+
+        if (ngx_http_variable_crc32(r, vv, (uintptr_t) name) == NGX_OK) {
+            return vv;
+        }
+
+        return NULL;
+    }
+
+    if (ngx_strncmp(name->data, "md5_", 4) == 0) {
+
+        if (ngx_http_variable_md5(r, vv, (uintptr_t) name) == NGX_OK) {
+            return vv;
+        }
+
+        return NULL;
+    }
+
     if (ngx_strncmp(name->data, "arg_", 4) == 0) {
 
         if (ngx_http_variable_argument(r, vv, (uintptr_t) name) == NGX_OK) {
@@ -514,6 +588,8 @@ ngx_http_get_variable(ngx_http_request_t *r, ngx_str_t *name, ngx_uint_t key,
         return NULL;
     }
 
+
+
     vv->not_found = 1;
 
     if (nowarn == 0) {
@@ -772,6 +848,231 @@ ngx_http_variable_cookie(ngx_http_request_t *r, ngx_http_variable_value_t *v,
 }
 
 
+#if (NGX_HTTP_SSI)
+static ngx_int_t
+ngx_http_variable_ssi(ngx_http_request_t *r, ngx_http_variable_value_t *v,
+    uintptr_t data)
+{
+    ngx_str_t  *name = (ngx_str_t *) data;
+    ngx_str_t  *vv;
+    ngx_str_t   s;
+    ngx_uint_t  key;
+
+    s.len = name->len - (sizeof("ssi_") - 1);
+    s.data = name->data + sizeof("ssi_") - 1;
+
+    vv = ngx_http_ssi_get_variable(r, &s, &key);
+
+    if (vv == NULL) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    v->len = vv->len;
+    v->valid = 1;
+    v->no_cacheable = 1;
+    v->not_found = 0;
+    v->data = vv->data;
+
+    return NGX_OK;
+}
+#endif
+
+
+static ngx_int_t
+ngx_http_variable_urlencode(ngx_http_request_t *r, ngx_http_variable_value_t *v,
+    uintptr_t data)
+{
+    ngx_str_t *name = (ngx_str_t *) data;
+
+    ngx_str_t  sub_name;
+
+    ngx_uint_t key;
+
+    ngx_http_variable_value_t *vv;
+
+    sub_name.len = name->len - (sizeof("urlencode_") - 1);
+    sub_name.data = name->data + sizeof("urlencode_") - 1;
+
+    key = ngx_hash_strlow(sub_name.data, sub_name.data, sub_name.len);
+
+    vv = ngx_http_get_variable(r, &sub_name, key, 0);
+
+    if (vv == NULL || !vv->valid) {
+        return NGX_ERROR;
+    }
+
+    if (vv->not_found) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    v->len = vv->len +
+	2 * ngx_escape_uri(NULL, vv->data, vv->len, NGX_ESCAPE_ARGS);
+
+    v->data = ngx_palloc(r->pool, v->len);
+    if (v->data == NULL) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    (void) ngx_escape_uri(v->data, vv->data, vv->len, NGX_ESCAPE_ARGS);
+
+    v->valid = 1;
+    v->not_found = 0;
+    v->no_cacheable = vv->no_cacheable;
+
+    return NGX_OK;
+}
+
+
+static ngx_int_t
+ngx_http_variable_urldecode(ngx_http_request_t *r, ngx_http_variable_value_t *v,
+    uintptr_t data)
+{
+    ngx_str_t *name = (ngx_str_t *) data;
+
+    u_char    *dst, *src;
+    ngx_str_t  sub_name;
+    ngx_uint_t key;
+
+    ngx_http_variable_value_t *vv;
+
+    sub_name.len = name->len - (sizeof("urldecode_") - 1);
+    sub_name.data = name->data + sizeof("urldecode_") - 1;
+
+    key = ngx_hash_strlow(sub_name.data, sub_name.data, sub_name.len);
+
+    vv = ngx_http_get_variable(r, &sub_name, key, 0);
+
+    if (vv == NULL || !vv->valid) {
+        return NGX_ERROR;
+    }
+
+    if (vv->not_found) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    v->len = vv->len;
+
+    v->data = ngx_palloc(r->pool, v->len);
+    if (v->data == NULL) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    dst = v->data;
+    src = vv->data;
+
+    ngx_unescape_uri(&dst, &src, vv->len, NGX_ESCAPE_ARGS);
+
+    v->len = dst - v->data;
+
+    v->valid = 1;
+    v->not_found = 0;
+    v->no_cacheable = vv->no_cacheable;
+
+    return NGX_OK;
+}
+
+
+static ngx_int_t
+ngx_http_variable_crc32(ngx_http_request_t *r, ngx_http_variable_value_t *v,
+    uintptr_t data)
+{
+    ngx_str_t *name = (ngx_str_t *) data;
+
+    ngx_str_t  sub_name;
+    ngx_uint_t key;
+
+    ngx_http_variable_value_t *vv;
+
+    sub_name.len = name->len - (sizeof("crc32_") - 1);
+    sub_name.data = name->data + sizeof("crc32_") - 1;
+
+    key = ngx_hash_strlow(sub_name.data, sub_name.data, sub_name.len);
+
+    vv = ngx_http_get_variable(r, &sub_name, key, 0);
+
+    if (vv == NULL || !vv->valid) {
+        return NGX_ERROR;
+    }
+
+    if (vv->not_found) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    v->len = sizeof("3C32515A") - 1;
+
+    v->data = ngx_palloc(r->pool, v->len);
+    if (v->data == NULL) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    ngx_sprintf(v->data, "%08XD", ngx_crc32_long(vv->data, vv->len));
+
+    v->valid = 1;
+    v->not_found = 0;
+    v->no_cacheable = vv->no_cacheable;
+
+    return NGX_OK;
+}
+
+
+static ngx_int_t
+ngx_http_variable_md5(ngx_http_request_t *r, ngx_http_variable_value_t *v,
+    uintptr_t data)
+{
+    ngx_str_t *name = (ngx_str_t *) data;
+
+    ngx_str_t  sub_name;
+    ngx_uint_t key;
+    ngx_md5_t  md5;
+    uint32_t   hash[4];
+
+    ngx_http_variable_value_t *vv;
+
+    sub_name.len = name->len - (sizeof("md5_") - 1);
+    sub_name.data = name->data + sizeof("md5_") - 1;
+
+    key = ngx_hash_strlow(sub_name.data, sub_name.data, sub_name.len);
+
+    vv = ngx_http_get_variable(r, &sub_name, key, 0);
+
+    if (vv == NULL || !vv->valid) {
+        return NGX_ERROR;
+    }
+
+    if (vv->not_found) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    v->len = sizeof("7002945D4B8D9E472866092689DB3EAD") - 1;
+
+    v->data = ngx_palloc(r->pool, v->len);
+    if (v->data == NULL) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    ngx_md5_init(&md5);
+    ngx_md5_update(&md5, vv->data, vv->len);
+    ngx_md5_final((u_char*)hash, &md5);
+
+    ngx_sprintf(v->data, "%08XD%08XD%08XD%08XD", hash[0], hash[1], hash[2], hash[3]);
+
+    v->valid = 1;
+    v->not_found = 0;
+    v->no_cacheable = vv->no_cacheable;
+
+    return NGX_OK;
+}
+
+
 static ngx_int_t
 ngx_http_variable_argument(ngx_http_request_t *r, ngx_http_variable_value_t *v,
     uintptr_t data)
@@ -1376,6 +1677,50 @@ ngx_http_variable_sent_last_modified(ngx_http_request_t *r,
 
 
 static ngx_int_t
+ngx_http_variable_sent_etag(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data)
+{
+    u_char  *p;
+
+    if (r->headers_out.etag) {
+        v->len = r->headers_out.etag->value.len;
+        v->valid = 1;
+        v->no_cacheable = 0;
+        v->not_found = 0;
+        v->data = r->headers_out.etag->value.data;
+
+        return NGX_OK;
+    }
+
+    if (r->headers_out.etag_size >= 0 &&
+        r->headers_out.etag_time >= 0 &&
+        (ngx_int_t)r->headers_out.etag_uniq >= 0) {
+        p = ngx_pnalloc(r->pool,
+                   sizeof("ETag: ") - 1 + NGX_OFF_T_LEN + sizeof("_") - 1
+                   + NGX_TIME_T_LEN + sizeof("_") - 1 + NGX_INT_T_LEN);
+        if (p == NULL) {
+            return NGX_ERROR;
+        }
+
+        v->len = ngx_sprintf(p, "ETag: %XO-%XM-%Xd",
+                             r->headers_out.etag_size,
+                             r->headers_out.etag_time,
+                             r->headers_out.etag_uniq) - p;
+        v->valid = 1;
+        v->no_cacheable = 0;
+        v->not_found = 0;
+        v->data = p;
+
+        return NGX_OK;
+    }
+
+    v->not_found = 1;
+
+    return NGX_OK;
+}
+
+
+static ngx_int_t
 ngx_http_variable_sent_connection(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data)
 {
@@ -1545,6 +1890,26 @@ ngx_http_variable_pid(ngx_http_request_t *r,
     return NGX_OK;
 }
 
+static ngx_int_t
+ngx_http_variable_timestamp(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data)
+{
+    u_char  *p;
+
+    p = ngx_pnalloc(r->pool, NGX_INT64_LEN);
+    if (p == NULL) {
+        return NGX_ERROR;
+    }
+
+    v->len = ngx_sprintf(p, "%T", ngx_time()) - p;
+    v->valid = 1;
+    v->no_cacheable = 0;
+    v->not_found = 0;
+    v->data = p;
+
+    return NGX_OK;
+}
+
 
 ngx_int_t
 ngx_http_variables_add_core_vars(ngx_conf_t *cf)
@@ -1658,6 +2023,43 @@ ngx_http_variables_init_vars(ngx_conf_t *cf)
             continue;
         }
 
+#if (NGX_HTTP_SSI)
+        if (ngx_strncmp(v[i].name.data, "ssi_", 7) == 0) {
+            v[i].get_handler = ngx_http_variable_ssi;
+            v[i].data = (uintptr_t) &v[i].name;
+
+            continue;
+        }
+#endif
+
+        if (ngx_strncmp(v[i].name.data, "urlencode_", 10) == 0) {
+            v[i].get_handler = ngx_http_variable_urlencode;
+            v[i].data = (uintptr_t) &v[i].name;
+
+            continue;
+        }
+
+        if (ngx_strncmp(v[i].name.data, "urldecode_", 10) == 0) {
+            v[i].get_handler = ngx_http_variable_urldecode;
+            v[i].data = (uintptr_t) &v[i].name;
+
+            continue;
+        }
+
+        if (ngx_strncmp(v[i].name.data, "crc32_", 6) == 0) {
+            v[i].get_handler = ngx_http_variable_crc32;
+            v[i].data = (uintptr_t) &v[i].name;
+
+            continue;
+        }
+
+        if (ngx_strncmp(v[i].name.data, "md5_", 4) == 0) {
+            v[i].get_handler = ngx_http_variable_md5;
+            v[i].data = (uintptr_t) &v[i].name;
+
+            continue;
+        }
+
         if (ngx_strncmp(v[i].name.data, "arg_", 4) == 0) {
             v[i].get_handler = ngx_http_variable_argument;
             v[i].data = (uintptr_t) &v[i].name;
diff --git a/src/os/unix/ngx_alloc.h b/src/os/unix/ngx_alloc.h
index c7a31aa..4250490 100644
--- a/src/os/unix/ngx_alloc.h
+++ b/src/os/unix/ngx_alloc.h
@@ -15,8 +15,14 @@
 void *ngx_alloc(size_t size, ngx_log_t *log);
 void *ngx_calloc(size_t size, ngx_log_t *log);
 
-#define ngx_free          free
+#if (OBSD_MALLOC) || (JEMALLOC)
+
+#define NGX_HAVE_POSIX_MEMALIGN 1
+#define NGX_HAVE_MEMALIGN       1
 
+#endif	/* (OBSD_MALLOC) || (JEMALLOC) */
+
+#define ngx_free          free
 
 /*
  * Linux has memalign() or posix_memalign()
@@ -35,7 +41,6 @@ void *ngx_memalign(size_t alignment, size_t size, ngx_log_t *log);
 
 #endif
 
-
 extern ngx_uint_t  ngx_pagesize;
 extern ngx_uint_t  ngx_pagesize_shift;
 extern ngx_uint_t  ngx_cacheline_size;
